<html>
<head>
<title>OgreSceneNode.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSceneNode.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSceneNode_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _SceneNode_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _SceneNode_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreNode_8h.html">OgreNode.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039     <span class="comment">// forward decl</span>
<a name="l00040"></a>00040     <span class="keyword">struct </span>VisibleObjectsBoundsInfo;
<a name="l00041"></a>00041 
<a name="l00057"></a><a class="code" href="classOgre_1_1SceneNode.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00060"></a><a class="code" href="classOgre_1_1SceneNode.html#a49043fde03f6003b0cfe1a65f2ff64df">00060</a>         <span class="keyword">typedef</span> HashMap&lt;String, MovableObject*&gt; <a class="code" href="classOgre_1_1SceneNode.html#a49043fde03f6003b0cfe1a65f2ff64df">ObjectMap</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1SceneNode.html#a0e2fa88602b6dedc628b66246c1469c9">00061</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;ObjectMap&gt;</a> <a class="code" href="classOgre_1_1SceneNode.html#a0e2fa88602b6dedc628b66246c1469c9">ObjectIterator</a>;
<a name="l00062"></a><a class="code" href="classOgre_1_1SceneNode.html#a87b7fca094d8a66c3a2651916197d052">00062</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;ObjectMap&gt;</a> <a class="code" href="classOgre_1_1SceneNode.html#a87b7fca094d8a66c3a2651916197d052">ConstObjectIterator</a>;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keyword">protected</span>:
<a name="l00065"></a><a class="code" href="classOgre_1_1SceneNode.html#a92ed6ce65738128bee3cfcbb9074dab7">00065</a>         <a class="code" href="classOgre_1_1SceneNode.html#a49043fde03f6003b0cfe1a65f2ff64df">ObjectMap</a> <a class="code" href="classOgre_1_1SceneNode.html#a92ed6ce65738128bee3cfcbb9074dab7">mObjectsByName</a>;
<a name="l00066"></a>00066 
<a name="l00068"></a><a class="code" href="classOgre_1_1SceneNode.html#ab63dc19d99002d2634db61fdfb2042bc">00068</a>         <a class="code" href="classOgre_1_1WireBoundingBox.html" title="Allows the rendering of a wireframe bounding box.">WireBoundingBox</a> *<a class="code" href="classOgre_1_1SceneNode.html#ab63dc19d99002d2634db61fdfb2042bc" title="Pointer to a Wire Bounding Box for this Node.">mWireBoundingBox</a>;
<a name="l00070"></a><a class="code" href="classOgre_1_1SceneNode.html#a2a23d7a4772313b1d4568b946dfe23a0">00070</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SceneNode.html#a2a23d7a4772313b1d4568b946dfe23a0" title="Flag that determines if the bounding box of the node should be displayed.">mShowBoundingBox</a>;
<a name="l00071"></a><a class="code" href="classOgre_1_1SceneNode.html#a6f7d07c6abffa9ab419165696471a874">00071</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SceneNode.html#a6f7d07c6abffa9ab419165696471a874">mHideBoundingBox</a>;
<a name="l00072"></a>00072 
<a name="l00074"></a><a class="code" href="classOgre_1_1SceneNode.html#a3ed43b1903a0255a82ee41571b3ac108">00074</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* <a class="code" href="classOgre_1_1SceneNode.html#a3ed43b1903a0255a82ee41571b3ac108" title="SceneManager which created this node.">mCreator</a>;
<a name="l00075"></a>00075 
<a name="l00077"></a><a class="code" href="classOgre_1_1SceneNode.html#aae5a245a9ef39e8a32f15360b7404d92">00077</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1SceneNode.html#aae5a245a9ef39e8a32f15360b7404d92" title="World-Axis aligned bounding box, updated only through _update.">mWorldAABB</a>;
<a name="l00078"></a>00078 
<a name="l00080"></a>00080         <span class="keywordtype">void</span> updateFromParentImpl(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChildImpl(<span class="keywordtype">void</span>);
<a name="l00084"></a>00084 
<a name="l00086"></a>00086         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChildImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00087"></a>00087 
<a name="l00089"></a>00089         <span class="keywordtype">void</span> setParent(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* parent);
<a name="l00090"></a>00090 
<a name="l00094"></a>00094         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInSceneGraph(<span class="keywordtype">bool</span> inGraph);
<a name="l00095"></a>00095 
<a name="l00097"></a><a class="code" href="classOgre_1_1SceneNode.html#a79fe2c7ff9599191a58902cdae1b3a3f">00097</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SceneNode.html#a79fe2c7ff9599191a58902cdae1b3a3f" title="Whether to yaw around a fixed axis.">mYawFixed</a>;
<a name="l00099"></a><a class="code" href="classOgre_1_1SceneNode.html#a37db788390eb6da498e0e4bfeb2400e1">00099</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1SceneNode.html#a37db788390eb6da498e0e4bfeb2400e1" title="Fixed axis to yaw around.">mYawFixedAxis</a>;
<a name="l00100"></a>00100 
<a name="l00102"></a><a class="code" href="classOgre_1_1SceneNode.html#ad5ab7b1d824dc3be02e1f116d0801b40">00102</a>         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* <a class="code" href="classOgre_1_1SceneNode.html#ad5ab7b1d824dc3be02e1f116d0801b40" title="Auto tracking target.">mAutoTrackTarget</a>;
<a name="l00104"></a><a class="code" href="classOgre_1_1SceneNode.html#a79a962278ebfd05a0371659f0915650e">00104</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1SceneNode.html#a79a962278ebfd05a0371659f0915650e" title="Tracking offset for fine tuning.">mAutoTrackOffset</a>;
<a name="l00106"></a><a class="code" href="classOgre_1_1SceneNode.html#a3718047a30a7575e283604ae27bdc31b">00106</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1SceneNode.html#a3718047a30a7575e283604ae27bdc31b" title="Local &#39;normal&#39; direction vector.">mAutoTrackLocalDirection</a>;
<a name="l00108"></a><a class="code" href="classOgre_1_1SceneNode.html#abde5946531210225faafcf92b7eb4660">00108</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SceneNode.html#abde5946531210225faafcf92b7eb4660" title="Is this node a current part of the scene graph?">mIsInSceneGraph</a>;
<a name="l00109"></a>00109     <span class="keyword">public</span>:
<a name="l00114"></a>00114         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* creator);
<a name="l00119"></a>00119         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00120"></a>00120         ~<a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>();
<a name="l00121"></a>00121 
<a name="l00127"></a>00127         <span class="keyword">virtual</span> <span class="keywordtype">void</span> attachObject(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj);
<a name="l00128"></a>00128 
<a name="l00131"></a>00131         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> numAttachedObjects(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00137"></a>00137         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* getAttachedObject(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00138"></a>00138 
<a name="l00142"></a>00142         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* getAttachedObject(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00143"></a>00143 
<a name="l00149"></a>00149         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* detachObject(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00151"></a>00151         <span class="keyword">virtual</span> <span class="keywordtype">void</span> detachObject(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj);
<a name="l00152"></a>00152 
<a name="l00154"></a>00154         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* detachObject(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00155"></a>00155 
<a name="l00158"></a>00158         <span class="keyword">virtual</span> <span class="keywordtype">void</span> detachAllObjects(<span class="keywordtype">void</span>);
<a name="l00159"></a>00159 
<a name="l00163"></a><a class="code" href="classOgre_1_1SceneNode.html#a4e8a3cc40a8b7cac0ea3dd761e51beca">00163</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SceneNode.html#a4e8a3cc40a8b7cac0ea3dd761e51beca" title="Determines whether this node is in the scene graph, i.e.">isInSceneGraph</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIsInSceneGraph; }
<a name="l00164"></a>00164 
<a name="l00169"></a><a class="code" href="classOgre_1_1SceneNode.html#af0481ea7c8fb0c5e8a9422dc7ecb60a8">00169</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SceneNode.html#af0481ea7c8fb0c5e8a9422dc7ecb60a8" title="Notifies this SceneNode that it is the root scene node.">_notifyRootNode</a>(<span class="keywordtype">void</span>) { mIsInSceneGraph = <span class="keyword">true</span>; }
<a name="l00170"></a>00170             
<a name="l00171"></a>00171 
<a name="l00184"></a>00184         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _update(<span class="keywordtype">bool</span> updateChildren, <span class="keywordtype">bool</span> parentHasChanged);
<a name="l00185"></a>00185 
<a name="l00188"></a>00188         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateBounds(<span class="keywordtype">void</span>);
<a name="l00189"></a>00189 
<a name="l00208"></a>00208         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _findVisibleObjects(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam, <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue, 
<a name="l00209"></a>00209             <a class="code" href="structOgre_1_1VisibleObjectsBoundsInfo.html" title="Structure collecting together information about the visible objects that have been discovered in a sc...">VisibleObjectsBoundsInfo</a>* visibleBounds, 
<a name="l00210"></a>00210             <span class="keywordtype">bool</span> includeChildren = <span class="keyword">true</span>, <span class="keywordtype">bool</span> displayNodes = <span class="keyword">false</span>, <span class="keywordtype">bool</span> onlyShadowCasters = <span class="keyword">false</span>);
<a name="l00211"></a>00211 
<a name="l00217"></a>00217         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; _getWorldAABB(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00218"></a>00218 
<a name="l00229"></a>00229         <span class="keyword">virtual</span> ObjectIterator getAttachedObjectIterator(<span class="keywordtype">void</span>);
<a name="l00240"></a>00240         <span class="keyword">virtual</span> ConstObjectIterator getAttachedObjectIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00241"></a>00241 
<a name="l00247"></a><a class="code" href="classOgre_1_1SceneNode.html#ae17ea5739bf85c988cb21d0df298976f">00247</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* <a class="code" href="classOgre_1_1SceneNode.html#ae17ea5739bf85c988cb21d0df298976f" title="Gets the creator of this scene node.">getCreator</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCreator; }
<a name="l00248"></a>00248 
<a name="l00259"></a>00259         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAndDestroyChild(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00260"></a>00260 
<a name="l00271"></a>00271         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAndDestroyChild(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00272"></a>00272 
<a name="l00279"></a>00279         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAndDestroyAllChildren(<span class="keywordtype">void</span>);
<a name="l00280"></a>00280 
<a name="l00285"></a>00285         <span class="keyword">virtual</span> <span class="keywordtype">void</span> showBoundingBox(<span class="keywordtype">bool</span> bShow);
<a name="l00286"></a>00286 
<a name="l00292"></a>00292         <span class="keyword">virtual</span> <span class="keywordtype">void</span> hideBoundingBox(<span class="keywordtype">bool</span> bHide);
<a name="l00293"></a>00293 
<a name="l00296"></a>00296         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _addBoundingBoxToQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00297"></a>00297 
<a name="l00305"></a>00305         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getShowBoundingBox() <span class="keyword">const</span>;
<a name="l00306"></a>00306 
<a name="l00313"></a>00313         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* createChildSceneNode(
<a name="l00314"></a>00314             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; translate = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>, 
<a name="l00315"></a>00315             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rotate = <a class="code" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a> );
<a name="l00316"></a>00316 
<a name="l00326"></a>00326         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* createChildSceneNode(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; translate = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rotate = <a class="code" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a>);
<a name="l00327"></a>00327 
<a name="l00344"></a>00344         <span class="keyword">virtual</span> <span class="keywordtype">void</span> findLights(<a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; destList, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radius, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> lightMask = 0xFFFFFFFF) <span class="keyword">const</span>;
<a name="l00345"></a>00345 
<a name="l00360"></a>00360         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFixedYawAxis( <span class="keywordtype">bool</span> useFixed, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; fixedAxis = <a class="code" href="classOgre_1_1Vector3.html#a8d1a1f7af535bcc8d9c78b1732bc1b90">Vector3::UNIT_Y</a> );
<a name="l00361"></a>00361 
<a name="l00364"></a>00364         <span class="keyword">virtual</span> <span class="keywordtype">void</span> yaw(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle, TransformSpace relativeTo = TS_LOCAL);
<a name="l00375"></a>00375         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDirection(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z, 
<a name="l00376"></a>00376             TransformSpace relativeTo = TS_LOCAL, 
<a name="l00377"></a>00377             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; localDirectionVector = <a class="code" href="classOgre_1_1Vector3.html#abdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>);
<a name="l00378"></a>00378 
<a name="l00389"></a>00389         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDirection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec, TransformSpace relativeTo = TS_LOCAL, 
<a name="l00390"></a>00390             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; localDirectionVector = <a class="code" href="classOgre_1_1Vector3.html#abdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>);
<a name="l00397"></a>00397         <span class="keyword">virtual</span> <span class="keywordtype">void</span> lookAt( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; targetPoint, TransformSpace relativeTo,
<a name="l00398"></a>00398             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; localDirectionVector = <a class="code" href="classOgre_1_1Vector3.html#abdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>);
<a name="l00417"></a>00417         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAutoTracking(<span class="keywordtype">bool</span> enabled, <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* <span class="keyword">const</span> target = 0, 
<a name="l00418"></a>00418             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; localDirectionVector = <a class="code" href="classOgre_1_1Vector3.html#abdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>,
<a name="l00419"></a>00419             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; offset = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>);
<a name="l00421"></a><a class="code" href="classOgre_1_1SceneNode.html#a9f25ff62bc7c5f3573872d1937edd35b">00421</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* <a class="code" href="classOgre_1_1SceneNode.html#a9f25ff62bc7c5f3573872d1937edd35b" title="Get the auto tracking target for this node, if any.">getAutoTrackTarget</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mAutoTrackTarget; }
<a name="l00423"></a><a class="code" href="classOgre_1_1SceneNode.html#a3bfbb62bc1e7879e3ed8efab74ff1449">00423</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1SceneNode.html#a3bfbb62bc1e7879e3ed8efab74ff1449" title="Get the auto tracking offset for this node, if the node is auto tracking.">getAutoTrackOffset</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mAutoTrackOffset; }
<a name="l00425"></a><a class="code" href="classOgre_1_1SceneNode.html#a1c7da5149270d58781185d6c94c90cf3">00425</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1SceneNode.html#a1c7da5149270d58781185d6c94c90cf3" title="Get the auto tracking local direction for this node, if it is auto tracking.">getAutoTrackLocalDirection</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mAutoTrackLocalDirection; }
<a name="l00427"></a>00427         <span class="keywordtype">void</span> _autoTrack(<span class="keywordtype">void</span>);
<a name="l00429"></a>00429         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* getParentSceneNode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00438"></a>00438         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVisible(<span class="keywordtype">bool</span> visible, <span class="keywordtype">bool</span> cascade = <span class="keyword">true</span>);
<a name="l00446"></a>00446         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipVisibility(<span class="keywordtype">bool</span> cascade = <span class="keyword">true</span>);
<a name="l00447"></a>00447 
<a name="l00457"></a>00457         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDebugDisplayEnabled(<span class="keywordtype">bool</span> enabled, <span class="keywordtype">bool</span> cascade = <span class="keyword">true</span>);
<a name="l00458"></a>00458 
<a name="l00460"></a>00460         <span class="keyword">virtual</span> DebugRenderable* getDebugRenderable();
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465     };
<a name="l00470"></a>00470 }<span class="comment">// namespace</span>
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
